<?php

declare(strict_types=1);

namespace Dedi\SyliusBannerPlugin\Repository;

use Sylius\Bundle\ResourceBundle\Doctrine\ORM\EntityRepository;

class AlertMessageRepository extends EntityRepository implements AlertMessageRepositoryInterface
{
    public function getAvailableAlertMessages(string $type): array
    {
        $today = new \DateTimeImmutable();
        $qb = $this->createQueryBuilder('am');
        $date = $this->createQueryBuilder('d')
            ->select($qb->expr()->max('d.createdAt'))
            ->andWhere($qb->expr()->eq('d.type', ':type'))
            ->andWhere($qb->expr()->eq('d.enabled', 1))
            ->setParameter('type', $type)
            ->getQuery()->getResult();

        return $qb->where($qb->expr()->eq('am.enabled', 1))
            ->andWhere($qb->expr()->eq('am.type', ':type'))
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.startDateTime'),
                $qb->expr()->lte('am.startDateTime', ':today'),
            ))
            ->andWhere($qb->expr()->orX(
                $qb->expr()->isNull('am.endDateTime'),
                $qb->expr()->gte('am.endDateTime', ':today'),
            ))
            ->andWhere($qb->expr()->eq('am.createdAt', ':date'))
            ->setMaxResults(1)
            ->setParameter('today', $today)
            ->setParameter('type', $type)
            ->setParameter('date', $date)
            ->getQuery()
            ->getResult()
            ;
    }
}
